"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
/*
 * This file is part of the Front Foundation package.
 *
 * Copyright (c) 2017-present LIN3S <info@lin3s.com>
 *
 * For the full copyright and license information, please view the LICENSE
 * file that was distributed with this source code.
 *
 * @author Mikel Tuesta <mikeltuesta@gmail.com>
 */

var defaultValueValidator = function defaultValueValidator(defaultValue, messages) {
  return {
    validateString: function validateString(value) {
      return value !== defaultValue;
    },
    messages: messages
  };
},
    phoneValidator = function phoneValidator(messages) {
  return {
    validateString: function validateString(value) {
      var re = /^[\+]?[(]?[0-9]{3}[)]?[-\s\.]?[0-9]{3}[-\s\.]?[0-9]{3,6}$/im; // eslint-disable-line no-useless-escape
      return re.test(value);
    },
    messages: messages
  };
};

exports.defaultValueValidator = defaultValueValidator;
exports.phoneValidator = phoneValidator;