'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _jquery = require('jquery');

var _jquery2 = _interopRequireDefault(_jquery);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /*
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * This file is part of the Front Foundation package.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * Copyright (c) 2017-present LIN3S <info@lin3s.com>
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * For the full copyright and license information, please view the LICENSE
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * file that was distributed with this source code.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * @author Mikel Tuesta <mikel@gmail.com>
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                */

var FormGroup = function (_React$Component) {
  _inherits(FormGroup, _React$Component);

  function FormGroup(props) {
    _classCallCheck(this, FormGroup);

    var _this = _possibleConstructorReturn(this, (FormGroup.__proto__ || Object.getPrototypeOf(FormGroup)).call(this, props));

    _this.state = {
      touched: false
    };

    _this.addParsleyValidator();

    // bre-bind method's context
    _this.onInputChange = _this.onInputChange.bind(_this);
    _this.onInputFocus = _this.onInputFocus.bind(_this);
    return _this;
  }

  _createClass(FormGroup, [{
    key: 'addParsleyValidator',
    value: function addParsleyValidator() {
      if (!this.props.parsleyValidationEnabled || this.props.type !== 'tel') {
        return;
      }

      var PHONE_VALUE_VALIDATOR = 'phone';

      if (window.Parsley.hasValidator(PHONE_VALUE_VALIDATOR)) {
        return;
      }

      window.Parsley.addValidator(PHONE_VALUE_VALIDATOR, {
        validateString: function validateString(value) {
          var re = /^[\+]?[(]?[0-9]{3}[)]?[-\s\.]?[0-9]{3}[-\s\.]?[0-9]{3,6}$/im; // eslint-disable-line no-useless-escape
          return re.test(value);
        },
        messages: this.props.parsleyValidationPhoneMessages
      });
    }
  }, {
    key: 'onInputChange',
    value: function onInputChange(event) {
      event.persist();
      this.props.onChanged(event.target.value);
    }
  }, {
    key: 'onInputFocus',
    value: function onInputFocus() {
      this.setState({
        touched: true
      });
    }
  }, {
    key: 'validate',
    value: function validate() {
      return (0, _jquery2.default)(this.input).parsley().validate();
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate(prevProps) {
      if (this.state.touched) {
        this.validate();
      }
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _this2 = this;

      if (this.props.parsleyValidationForm !== undefined) {
        (0, _jquery2.default)(this.props.parsleyValidationForm).on('submit.form_input', function (event) {
          if (_this2.validate() !== true) {
            event.preventDefault();
          }
        });
      }
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      if (this.props.parsleyValidationForm !== undefined) {
        (0, _jquery2.default)(this.props.parsleyValidationForm).off('submit.form_input');
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _this3 = this;

      var _props = this.props,
          id = _props.id,
          label = _props.label,
          required = _props.required,
          type = _props.type,
          parsleyValidationEnabled = _props.parsleyValidationEnabled;


      var needsPhoneValidation = parsleyValidationEnabled && type === 'tel' ? true : null;

      return _react2.default.createElement(
        'div',
        { className: 'form-group-input' },
        _react2.default.createElement(
          'div',
          { className: 'form-group-input__label' },
          _react2.default.createElement(
            'label',
            { className: 'form-label', htmlFor: id },
            required && _react2.default.createElement(
              'span',
              { className: 'form-label__required' },
              '*'
            ),
            label
          )
        ),
        _react2.default.createElement('input', {
          autoComplete: 'off',
          className: 'form-input',
          'data-parsley-phone': needsPhoneValidation,
          id: id,
          name: id,
          onChange: this.onInputChange,
          onFocus: this.onInputFocus,
          placeholder: label,
          ref: function ref(input) {
            _this3.input = input;
          },
          required: required,
          type: type })
      );
    }
  }]);

  return FormGroup;
}(_react2.default.Component);

FormGroup.propTypes = {
  id: _propTypes2.default.string.isRequired,
  label: _propTypes2.default.string.isRequired,
  onChanged: _propTypes2.default.func,
  parsleyValidationEnabled: _propTypes2.default.bool,
  parsleyValidationForm: _propTypes2.default.any,
  parsleyValidationPhoneMessages: _propTypes2.default.object,
  required: _propTypes2.default.bool,
  type: _propTypes2.default.string
};
FormGroup.defaultProps = {
  onChanged: function onChanged() {},
  parsleyValidationEnabled: false,
  parsleyValidationForm: undefined,
  parsleyValidationPhoneMessages: undefined,
  required: false,
  type: 'text'
};
exports.default = FormGroup;